Global camera_piv, camera, speed#
Global  mxs#, mys#,xang# ,yang# ,dest_xang# ,dest_yang#
Graphics3D 1024,768,32,1
SeedRnd MilliSecs ()
init_camera

	lev= CreateCube ()
	EntityType lev, 1 
	ScaleEntity lev,-10,-10,-10
	EntityPickMode lev,2
	EntityColor lev,100,100,100
	tex=LoadTexture ("003_.jpg")
	ScaleTexture tex,0.2,0.2
	EntityTexture lev,tex

L1=LoadMesh ("L.b3d")
L2=CopyEntity (L1)
L3=CopyEntity (L1)
L4=CopyEntity (L1)
L5=CopyEntity (L1)
L6=CopyEntity (L1)


light=CreateSphere ()
EntityAlpha light,0.5
MoveEntity light,0,5,0
EntityType light,2

Collisions 2,1,2,2


WT=CreateTimer (60)
tr=-1

k1#=1
k2#=10
k3#=10

	vx#=Rnd(-0.1,0.1)
	vy#=Rnd(-0.1,0.1)
	vz#=Rnd(-0.1,0.1)

Repeat
;----------------------------------------------------------------------------------------------------------------

If EntityCollided(light,1)
	vx#=Rnd(-0.1,0.1)
	vy#=Rnd(-0.1,0.1)
	vz#=Rnd(-0.1,0.1)
		r=Rand(0,2)*127
		g=Rand(0,2)*127
		b=Rand(0,2)*127
			EntityColor L1,r,g,b
			EntityColor L2,r,g,b
			EntityColor L3,r,g,b
			EntityColor L4,r,g,b
			EntityColor L5,r,g,b
			EntityColor L6,r,g,b
EndIf

TranslateEntity light,vx#,vy#,vz#


RotateEntity light,0,0,0
	ep=EntityPick (light,100)
		If ep
			PositionEntity L1,PickedX(),PickedY(),PickedZ()  
			AlignToVector L1,PickedNX (),PickedNY (), PickedNZ (),2,1
			MoveEntity L1,0,.1,0
			d#=EntityDistance (light,L1)
			ScaleEntity L1,d#*d#/k1#+k2#,d#*d#/k1#+k2#,d#*d#/k1#+k2#
			EntityAlpha L1,k3#/(d#*d#+0.1)
		EndIf

RotateEntity light,0,90,0
	ep=EntityPick (light,100)
		If ep
			PositionEntity L2,PickedX(),PickedY(),PickedZ()  
			AlignToVector L2,PickedNX (),PickedNY (), PickedNZ (),2,1
			MoveEntity L2,0,.1,0
			d#=EntityDistance (light,L2)
			ScaleEntity L2,d#*d#/k1#+k2#,d#*d#/k1#+k2#,d#*d#/k1#+k2#
			EntityAlpha L2,k3#/(d#*d#+0.1)
		EndIf

RotateEntity light,0,-90,0
	ep=EntityPick (light,100)
		If ep
			PositionEntity L3,PickedX(),PickedY(),PickedZ()  
			AlignToVector L3,PickedNX (),PickedNY (), PickedNZ (),2,1
			MoveEntity L3,0,.1,0
			d#=EntityDistance (light,L3)
			ScaleEntity L3,d#*d#/k1#+k2#,d#*d#/k1#+k2#,d#*d#/k1#+k2#
			EntityAlpha L3,k3#/(d#*d#+0.1)
		EndIf

RotateEntity light,90,0,0
	ep=EntityPick (light,100)
		If ep
			PositionEntity L4,PickedX(),PickedY(),PickedZ()  
			AlignToVector L4,PickedNX (),PickedNY (), PickedNZ (),2,1
			MoveEntity L4,0,.1,0
			d#=EntityDistance (light,L4)
			ScaleEntity L4,d#*d#/k1#+k2#,d#*d#/k1#+k2#,d#*d#/k1#+k2#
			EntityAlpha L4,k3#/(d#*d#+0.1)
		EndIf

RotateEntity light,-90,0,0
	ep=EntityPick (light,100)
		If ep
			PositionEntity L5,PickedX(),PickedY(),PickedZ()  
			AlignToVector L5,PickedNX (),PickedNY (), PickedNZ (),2,1
			MoveEntity L5,0,.1,0
			d#=EntityDistance (light,L5)
			ScaleEntity L5,d#*d#/k1#+k2#,d#*d#/k1#+k2#,d#*d#/k1#+k2#
			EntityAlpha L5,k3#/(d#*d#+0.1)
		EndIf

RotateEntity light,0,180,0
	ep=EntityPick (light,100)
		If ep
			PositionEntity L6,PickedX(),PickedY(),PickedZ()  
			AlignToVector L6,PickedNX (),PickedNY (), PickedNZ (),2,1
			MoveEntity L6,0,.1,0
			d#=EntityDistance (light,L6)
			ScaleEntity L6,d#*d#/k1#+k2#,d#*d#/k1#+k2#,d#*d#/k1#+k2#
			EntityAlpha L6,k3#/(d#*d#+0.1)
		EndIf





move_camera
UpdateWorld
RenderWorld
WaitTimer (WT)
Flip
Until KeyHit(1) 
End


 Function init_camera()
	   camera_piv =CreatePivot ()
		camera=CreateCamera()
		EntityParent camera,camera_piv
		speed# = .2								
 End Function
 Function move_camera ()
	mxs# = MouseXSpeed()/7.0
   mys# = MouseYSpeed()/7.0
    	
		dest_xang# = dest_xang + mys
		dest_yang# = dest_yang - mxs
	
		 xang# = CurveValue (xang, dest_xang, 7) 
	    	yang# = CurveValue (yang, dest_yang, 7)

	   If xang>89 xang=89:dest_xang=89
		If xang<-89 xang=-89:dest_xang=-89
    RotateEntity camera,xang, 0, 0
    RotateEntity camera_piv,0, yang, 0
	   MoveMouse GraphicsWidth()/2,GraphicsHeight()/2



If KeyDown(17) MoveEntity camera_piv,0,0,      speed 		
If KeyDown(31)	MoveEntity camera_piv,0,0,    -speed 
If KeyDown(30) MoveEntity camera_piv,-speed ,0,     0 
If KeyDown(32)  MoveEntity camera_piv,speed   ,0,    0
If KeyDown(16) TranslateEntity camera_piv,0,-speed   ,     0 
If KeyDown(18) TranslateEntity camera_piv,0,speed   ,    0

End Function
Function CurveValue#(current#,destination#,curve)
	current#=current#+((destination#-current#)/curve)
	Return current#
End Function
